//
//  area_of_interest.h
//  rg7II
//
//  Created by Martin Hruby on 10.02.12.
//

#ifndef rg7II_area_of_interest_h
#define rg7II_area_of_interest_h


#include "ras_phtile.h"
#include "tile_storage.h"

struct Ras_areas;

struct Ras_area_of_interest {
    
    Ras_area_of_interest() {
        included_in = 0;
        on = false;
    }
    
    // Switching on/off the impact of this area (priority on its tiles)
    void    switch_on();
    void    switch_off();
    void    add_to_tiles_priority(int delta);
    
    // 
    bool    reload_list_of_interesting_tiles();
    void    make_all_tiles_allocated();
    
    // moving
    bool    move_at_the_region(Region rg);
    
    Region  region;
    Tile_storage phtiles_in;
    Ras_areas *included_in;
    bool    on;
};


typedef std::set<Ras_area_of_interest *> Areas_set;
typedef Areas_set::iterator Areas_set_i;


struct Ras_areas {
    Ras_areas() {
        changed = false;
    }
    
    bool    add_area(Ras_area_of_interest *ar);
    bool    erase_area(Ras_area_of_interest *ar);
    
    ////////
    
    bool    changed;
};


#endif
