#include "compressed_ba.h"

void	Compressed_ba::allocate_internal_buffer()
{
	buf_size = USERDEFS.ba_default_size_of_buffer();
	buffer = new char [ buf_size ]; 
}


void	Compressed_ba::deallocate_internal_buffer()
{
	assert(internal_buffer_allocated);
	
	if (buffer)
		delete [] buffer;
}


bool	Compressed_ba::prepare()
{ 
	wp=buffer; 
	free_buf_size = buf_size;
	
	return buffer != 0;
}

char	*Compressed_ba::start_address()
{
	return buffer;
}


int	Compressed_ba::length()
{
	return (int) (wp-buffer);
}


bool	Compressed_ba::write_n_data(void *data, size_t sz)
{
	//std::cout << "write_n_data, bytes: " << sz << "\n";
	//std::cout << "free buf size " << free_buf_size << "\n";
	
	assert(sz <= free_buf_size);
	
	memmove(wp, data, sz);
	wp += sz;
	
	return true;
}

bool	Compressed_ba::read_n_data(void *data, size_t sz)
{
	memmove(data, wp, sz);
	wp += sz;
	
	return true;
}


bool	Compressed_ba::write_cell(dtype cell_value)
{
	return write_n_data((void*)&cell_value, sizeof(dtype));
}


bool	Compressed_ba::write_n_cells(dtype *cell_buf, size_t n)
{
	return true;
}


bool	Compressed_ba::read_cell(dtype &cell_value)
{
	return true;
}

