#ifndef	__GRASS_RASTER_ID
#define	__GRASS_RASTER_ID

#include "basics.h"

/*
	
	Complete identification of a single raster file within the GRASS naming convention system.
	
*/


enum	RG_IFACE_TYPE {
	RG_IFACE_GRASS = 0,
	RG_IFACE_RG7 = 1,
	RG_IFACE_WMS = 2
};


struct	RG_ID {
	RG_ID() {
		database = location = mapset = filename = "";
	}
	
	RG_ID(rstring fn) {
		database = location = mapset = "";
		filename = fn;
	}
	
	// key name for rg7_system maps
	rstring	registration_name();
	
	// is this mapset the PERMANENT mapset?
	bool	is_permanent_mapset();
	enum	RG_IFACE_TYPE file_iface_type();
	// is this file one of rg7 files?
	bool	is_rg7_file();
	
	// filenames of raster storage components
	rstring fn_cat();
	rstring	fn_cell();
	rstring	fn_cell_misc();
	rstring	fn_colr();
	// others TODO
	
	// file path of rg7's DB storage (e.g. SQLite3 iface)
	rstring	rg7_db_path();
	
	
	rstring	database, location, mapset, filename;
};

RG_ID	*rid(rstring fn);

#endif	/* __GRASS_RASTER_ID */