#ifndef	__POOL_OF_PHTILE_BUFS_H
#define	__POOL_OF_PHTILE_BUFS_H

#include "basics.h"

/*
	The pool is managed by a phys-file object.
	(configuration in the UserDefaults)
	TODO: for a better performance, the pool might be placed in rg7_sysem and so -- shared for all phys-files (! multi-threads)
		--> options in the USerDefs.
	
	RULES:
	1) The pool serves EVERY request -- size limits are supposed to be managed by the phys-file (make_ava..., needs_reallocate, ...)
	
	2) on allocation request, the pool decides (the particular method is TODO) an existing buffers to return or allocate a new one.
		--> buffer with the equal size as the requested one
		--> first buffer with appropriate size
		--> best fitting buffer
*/

struct	Pool_register {
	// container for buffers of the same size.
};

struct	Pool_of_Phtile_buffers {
	
	Pool_of_Phtile_buffers(int e_starting_sz=-1);
	~Pool_of_Phtile_buffers();
	
	void	set_actual_limit(int limit);
	int	get_actual_size();
	
	General_2D_buffer *allocate(ICoord req_tilesize);
	void	put_back(General_2D_buffer *buf);
	
	int	starting_size;
	int	current_size;
};

#endif	/* __POOL_OF_PHTILE_BUFS_H */