#ifndef	__RAS_METADATA_H
#define	__RAS_METADATA_H

#include "basics.h"

// TODO: define rstring names for metadata attributes

// store the attributes in ...
typedef	std::map<rstring, rstring> StrStr_Dictionary;

struct	Ras_metadata {
	Ras_metadata() {
		null_value = 0;
		is_reclassed = false;
	}
	
	// general access methods
	bool	setAttr(rstring name, rstring val);
	rstring	getAttr(rstring name);

	// the region of the raster
	Region	base_region;
	// minimum tile size (tiling size)
	ICoord	minimum_region;

	// which value is selected to express NULL value
	dtype	null_value;

	// if the raster is a reclassification of another one
	bool	is_reclassed;
	rstring	reclassed_from;
	
	// TODO: reclass system...
	//treclass_table reclass_table;

	// TODO: 
	// description of categories

	// TODO: (computing the statistics in an external program)
	// (not done in real-time)
	//Ras_statistics	stats;
};


#endif	/* __RAS_METADATA_H */

