#ifndef	__RAS_SQLITE3_INTERFACE_H
#define	__RAS_SQLITE3_INTERFACE_H

#include <sqlite3.h>

#include "ras_file_interface.h"

class	Ras_sqlite3_interface : public Ras_file_interface {
public:
	
	Ras_sqlite3_interface(RG_ID *erid=NULL);
	~Ras_sqlite3_interface();
	
	virtual	bool	open();
	virtual	bool	close();
	virtual	bool	create();
	virtual	bool	drop();
	
	virtual	bool	write_metadata();
	virtual	bool	load_metadata();
	
	virtual	void	transaction(bool begin);
	virtual	int	swap_tile(Ras_phtile *tile);
	virtual	int	load_swapped_tile(Ras_phtile *tile);
	virtual	int	swapped_tile_available(Ras_phtile *tile);
	
	sqlite3 *db;
	
	// support
	char	*io_buf;
	size_t	io_buf_size;
};

int metadata_callback(void *NotUsed, int argc, char **argv, char **azColName);

#endif	/* __RAS_SQLITE3_INTERFACE_H */

