#ifndef	__RAS_WIN_ABSTRACT_H
#define	__RAS_WIN_ABSTRACT_H

#include "ras_phys_file.h"
#include "ras_file_interface.h"

// Basic resampling class
// resamples a raster file using a given region (monitor)
// provides an access to single points

class	Ras_win_abstraction {
public:
	Ras_win_abstraction(Ras_phys_file &fl, Region emon) : file(fl), monitor(emon) {
	}
	
	ICoord	size() { return monitor.countXY(); }
	
//protected:
	// Write/Read based on a geographic coordinate
	void	wgeo(Coord coord, dtype v);
	dtype	rgeo(Coord coord);
	
	// Write/Read based on a logical coordinate
	dtype	rcell(ICoord cell_xy);
	void	wcell(ICoord cell_xy, dtype val);
	
	
////////////////////////////////
	
	Ras_phys_file	file;
	Region  monitor;
};

#endif	/* __RAS_WIN_ABSTRACT_H */