#include "ras_window.h"

bool    Ras_window::point_at(ICoord crd)
{
	currILB = crd;
	return load_window_contents();
}

dtype   Ras_window::operator() (int x, int y)
{
	ICoord xy(x,y);
	
	return wbuf->read(xy);
}

bool    Ras_window::load_window_contents()
{
	ICoord xy;
	
	for (xy.y=0; xy.y<size.y; xy.y++)
	for (xy.x=0; xy.x<size.x; xy.x++) {
		//std::cout << xy << "\n";
		wbuf->write(xy, rcell(currILB+xy));
	}
	
	return true;
}

void	Ras_window::export_bmp(rstring fn)
{
	mBMP kam;
        RGBApixel k;
        
        std::cout << "---- Ploting\n";
        
        kam.SetSize(size.x, size.y);
        kam.SetBitDepth(24);
        int     x, y;
	dtype	valc;
	
        for (y=0; y<size.y; y++) 
        for (x=0; x<size.x; x++) {
		valc = (*this)(x,y);
		//printf("VALC %d %d %d\n", x, y, valc);
		RGBApixel pix;
		pix.Red = valc*10;
		pix.Green = valc*5;
		pix.Blue = valc*3;
		pix.Alpha = 100;
		
                kam.SetPixel(x, y, pix);
        }
        
        kam.WriteToFile(fn.c_str());
}

