#include "rg7_system.h"

Region	RG7_system::monitor()
{
	return current_monitor;
}


void	RG7_system::set_monitor(rstring raster_fn)
{
	Ras_phys_file *phf = get_phys_file(raster_fn);
	if (!phf) return ;
	
	current_monitor = phf->region();
}


Ras_window 	*RG7_system::win_primitive(Ras_phys_file *phf, Region region, ICoord sz_window)
{
	if (!phf) return NULL;
	
	Ras_window *rw = new Ras_window(*phf, region, sz_window);	
	return rw;
}

Ras_window	*RG7_system::win(rstring raster_fn, ICoord mon_size, ICoord sz_window)
{
	Ras_phys_file *phf = get_phys_file(raster_fn);
	if (!phf) return NULL;
	
	Region mon(phf->iface.metad.base_region, mon_size);
	return win_primitive(get_phys_file(raster_fn), mon, sz_window);
}


Ras_window	*RG7_system::win(rstring raster_fn, ICoord sz_window)
{
	Ras_phys_file *phf = get_phys_file(raster_fn);
	if (!phf) return NULL;
	
	return win_primitive(get_phys_file(raster_fn), 
			phf->iface.metad.base_region, 
			     sz_window);
}

Ras_window	*RG7_system::win(rstring raster_fn)
{
	Ras_phys_file *phf = get_phys_file(raster_fn);
	if (!phf) return NULL;
	
	return win_primitive(get_phys_file(raster_fn), 
		phf->iface.metad.base_region, 
		phf->iface.metad.base_region.countXY());
	
}

