#include "rg7.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include <libpng12/png.h>

int	lex_val(FILE *sb)
{
	int zn = fgetc(sb);
	if (feof(sb)) return 0;
	
	while (isspace(zn)) {
		zn = fgetc(sb);
		if (feof(sb)) return 0;
	}

	if (zn=='*') return 0;

	
	char	str[100], *uk=str;
	while (isdigit(zn) || zn=='.') {
		*uk++=zn; 
		zn = fgetc(sb);
		if (feof(sb)) break;
	}
	*uk=0;

	float f = atoi(str);

	if (f>3000) {
		printf("Divna hodnota %f\n", f);
	}
	

	return atoi(str);
	
	
	fscanf(sb, "%f", &f);

	
	return (int) f;
}

void	import_grass(rstring fn, rstring myname, ICoord mreg, int max_avat)
{
	FILE *sb = fopen(fn.c_str(), "rt");
	assert(sb!=0);
	
	coord_type n, s, e, w;
	int 	rows, cols;
	
	bool	check_rw = false;
	bool	unlimited_cache = true;

	char	dum[200];

	fscanf(sb, "%s %lf ", dum, &n);
	fscanf(sb, "%s %lf ", dum, &s);
	fscanf(sb, "%s %lf ", dum, &e);
	fscanf(sb, "%s %lf ", dum, &w);
	fscanf(sb, "%s %d ", dum, &rows);
	fscanf(sb, "%s %d ", dum, &cols);
	
	assert(n>s);
	assert(e>w);

	printf("Importing raster: N=%.2g, S=%.2g, E=%.2g, W=%.2g [rows=%d, cols=%d]\n", 
	       n, s, e, w, rows, cols);

	// Region of the raster
	Region reg(Coord(w,s), Coord(e,n), cols, rows);	
	// Interface to the data storage
	RG_ID 	file_id = RG7.def_id_with_name(myname);
	Ras_sqlite3_interface iface(&file_id);

	iface.metad.base_region = reg;
	iface.metad.minimum_region = mreg;
	
	iface.create();
	
	printf("File (iface) created\n");

	Ras_phys_file layer(iface);

	//layer.max_available_tiles = max_avat;

	printf("Size of the cache: %d tiles\n", layer.max_available_tiles);

	int	val, y, x;

	printf("Starting to load the GRASS text export\n");
	
	General_2D_buffer bufa(ICoord(cols, 1));
	
	for (y=0; y<reg.countY(); y++) {
		for (x=0; x<reg.countX(); x++) {	
			ICoord lc(x,y);	       		
			val = lex_val(sb);
			
			layer.wcell(lc, val);
			
			//printf("WRT %d %d %d\n", lc.x, lc.y, val);
		}
	}

	fclose(sb);
	
	printf("Import finished. Now flushing the buffers and closing the files.\n");
	
	layer.close_all_tiles();
	
	printf("Konec testu S/L/T=[%d/%d]/%d/%d\n", iface.stat_swap, iface.stat_swapR, iface.stat_load, iface.stat_test);
}


void	import_png(rstring png, rstring rfn, ICoord tile_size)
{
}


int	main(int argc, char *argv[])
{		
	int	ts = atoi(argv[3]);
	int	maxav = -1;

	// orig f, gener name, tile sz, rnd, maxavailtiles
	
	import_grass(argv[1], argv[2], ICoord(ts, ts), maxav); 
	//import_png(argv[1], argv[2], ICoord(ts, ts));
}

