#include "tile_storage.h"

IntIdx	makepair(ICoord coord)
{
	return IntIdx(coord.x, coord.y);
}

bool	Tile_storage::exists(ICoord tile_xy)
{
	return map.count(makepair(tile_xy))>0;
}


Ras_phtile *Tile_storage::get(ICoord tile_xy, bool sure_exists)
{
	if (!sure_exists) {
		if (!exists(tile_xy)) return NULL;
	}
	
	return map[makepair(tile_xy)];
}


bool	Tile_storage::insert(Ras_phtile *pht)
{
	if (exists(pht->tile_xy)) 
		return false;
	
	map[makepair(pht->tile_xy)] = pht;
	return true;
}


bool	Tile_storage::erase(Ras_phtile *pht, bool sure_exists)
{
	if (!sure_exists) {
		if (!exists(pht->tile_xy)) return false;
	}
	
	map.erase(makepair(pht->tile_xy));
	return true;
}

